<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_DailyHotelContract ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_DailyHotelContract extends AbstractStructArrayBase
{
    /**
     * The DailyContract
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_DailyHotelContract[]
     */
    public $DailyContract;
    /**
     * Constructor method for ArrayOfJP_DailyHotelContract
     * @uses ArrayOfJP_DailyHotelContract::setDailyContract()
     * @param \StructType\JP_DailyHotelContract[] $dailyContract
     */
    public function __construct(array $dailyContract = array())
    {
        $this
            ->setDailyContract($dailyContract);
    }
    /**
     * Get DailyContract value
     * @return \StructType\JP_DailyHotelContract[]|null
     */
    public function getDailyContract()
    {
        return $this->DailyContract;
    }
    /**
     * This method is responsible for validating the values passed to the setDailyContract method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDailyContract method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDailyContractForArrayConstraintsFromSetDailyContract(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_DailyHotelContractDailyContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_DailyHotelContractDailyContractItem instanceof \StructType\JP_DailyHotelContract) {
                $invalidValues[] = is_object($arrayOfJP_DailyHotelContractDailyContractItem) ? get_class($arrayOfJP_DailyHotelContractDailyContractItem) : sprintf('%s(%s)', gettype($arrayOfJP_DailyHotelContractDailyContractItem), var_export($arrayOfJP_DailyHotelContractDailyContractItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DailyContract property can only contain items of type \StructType\JP_DailyHotelContract, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DailyContract value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_DailyHotelContract[] $dailyContract
     * @return \ArrayType\ArrayOfJP_DailyHotelContract
     */
    public function setDailyContract(array $dailyContract = array())
    {
        // validation for constraint: array
        if ('' !== ($dailyContractArrayErrorMessage = self::validateDailyContractForArrayConstraintsFromSetDailyContract($dailyContract))) {
            throw new \InvalidArgumentException($dailyContractArrayErrorMessage, __LINE__);
        }
        $this->DailyContract = $dailyContract;
        return $this;
    }
    /**
     * Add item to DailyContract value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_DailyHotelContract $item
     * @return \ArrayType\ArrayOfJP_DailyHotelContract
     */
    public function addToDailyContract(\StructType\JP_DailyHotelContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_DailyHotelContract) {
            throw new \InvalidArgumentException(sprintf('The DailyContract property can only contain items of type \StructType\JP_DailyHotelContract, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DailyContract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_DailyHotelContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_DailyHotelContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_DailyHotelContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_DailyHotelContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_DailyHotelContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DailyContract
     */
    public function getAttributeName()
    {
        return 'DailyContract';
    }
}
